#include <hc11e1.h>
#include "utils.h"
#include "sonar.h"

int sonarRange(int unit)
{
 int binBit, iniBit, echoBit;
 int rng,tstart,tend,ctof;
 if(unit==LEFT)
 {
  binBit=7;
  iniBit=6;
  echoBit=4;
 }
 if(unit==RIGHT)
 {
  binBit=4;
  iniBit=5;
  echoBit=5;
 }
 bitSet(&_H11PORTB,binBit,OFF); // BINH
 bitSet(&_H11PORTB,iniBit,ON);  // INIT
 ctof=getTOF();
 tstart=_H11TCNT;
 delayms(1);
 bitSet(&_H11PORTB,binBit,ON);
 while(!(_H11PORTE & bit(echoBit)))
 {
  if((getTOF()-ctof)>4) break;
 }
 tend=_H11TCNT;
 ctof=getTOF()-ctof;
 if(ctof==0)
 {
  rng=(tend-tstart)/10;
 }
 else if(ctof==1)
 {
  rng=(65535-tstart)/10;
  rng+=tend/10;
 }
 else if(ctof>1)
 {
  rng=(65535-tstart)/10;
  rng+=6553.5*ctof;
  rng+=tend/10;
 }
 rng=0.06*rng;
 rng=rng/2;
 bitSet(&_H11PORTB,iniBit,OFF);
 delayms(20);
 return rng;
}
